
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Capa_actionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const capa_actions = await db.capa_actions.create(
            {
                id: data.id || undefined,
        
        capa_number: data.capa_number
        ||
        null
            ,
            
        action_type: data.action_type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        root_cause: data.root_cause
        ||
        null
            ,
            
        action_plan: data.action_plan
        ||
        null
            ,
            
        due_at: data.due_at
        ||
        null
            ,
            
        implemented_at: data.implemented_at
        ||
        null
            ,
            
        verified_at: data.verified_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await capa_actions.setNonconformance( data.nonconformance || null, {
            transaction,
        });
        
        await capa_actions.setOwner( data.owner || null, {
            transaction,
        });
        
        await capa_actions.setVerified_by( data.verified_by || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.capa_actions.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: capa_actions.id,
            },
            data.attachments,
            options,
        );
        

        return capa_actions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const capa_actionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                capa_number: item.capa_number
            ||
            null
            ,
            
                action_type: item.action_type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                root_cause: item.root_cause
            ||
            null
            ,
            
                action_plan: item.action_plan
            ||
            null
            ,
            
                due_at: item.due_at
            ||
            null
            ,
            
                implemented_at: item.implemented_at
            ||
            null
            ,
            
                verified_at: item.verified_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const capa_actions = await db.capa_actions.bulkCreate(capa_actionsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < capa_actions.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.capa_actions.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: capa_actions[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return capa_actions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const capa_actions = await db.capa_actions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.capa_number !== undefined) updatePayload.capa_number = data.capa_number;
        
        
        if (data.action_type !== undefined) updatePayload.action_type = data.action_type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.root_cause !== undefined) updatePayload.root_cause = data.root_cause;
        
        
        if (data.action_plan !== undefined) updatePayload.action_plan = data.action_plan;
        
        
        if (data.due_at !== undefined) updatePayload.due_at = data.due_at;
        
        
        if (data.implemented_at !== undefined) updatePayload.implemented_at = data.implemented_at;
        
        
        if (data.verified_at !== undefined) updatePayload.verified_at = data.verified_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await capa_actions.update(updatePayload, {transaction});

        
        
        if (data.nonconformance !== undefined) {
            await capa_actions.setNonconformance(
              
              data.nonconformance,
              
              { transaction }
            );
        }
        
        if (data.owner !== undefined) {
            await capa_actions.setOwner(
              
              data.owner,
              
              { transaction }
            );
        }
        
        if (data.verified_by !== undefined) {
            await capa_actions.setVerified_by(
              
              data.verified_by,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.capa_actions.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: capa_actions.id,
            },
            data.attachments,
            options,
        );
        

        return capa_actions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const capa_actions = await db.capa_actions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of capa_actions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of capa_actions) {
                await record.destroy({transaction});
            }
        });


        return capa_actions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const capa_actions = await db.capa_actions.findByPk(id, options);

        await capa_actions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await capa_actions.destroy({
            transaction
        });

        return capa_actions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const capa_actions = await db.capa_actions.findOne(
            { where },
            { transaction },
        );

        if (!capa_actions) {
            return capa_actions;
        }

        const output = capa_actions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.nonconformance = await capa_actions.getNonconformance({
            transaction
        });
        
        
        output.owner = await capa_actions.getOwner({
            transaction
        });
        
        
        output.verified_by = await capa_actions.getVerified_by({
            transaction
        });
        
        
        output.attachments = await capa_actions.getAttachments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.nonconformances,
        as: 'nonconformance',
        
        where: filter.nonconformance ? {
          [Op.or]: [
            { id: { [Op.in]: filter.nonconformance.split('|').map(term => Utils.uuid(term)) } },
            {
              ncr_number: {
                [Op.or]: filter.nonconformance.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'owner',
        
        where: filter.owner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'verified_by',
        
        where: filter.verified_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.verified_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.verified_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.capa_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'capa_actions',
                        'capa_number',
                        filter.capa_number,
                    ),
                };
            }
            
            if (filter.root_cause) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'capa_actions',
                        'root_cause',
                        filter.root_cause,
                    ),
                };
            }
            
            if (filter.action_plan) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'capa_actions',
                        'action_plan',
                        filter.action_plan,
                    ),
                };
            }
            

            
            

            
            if (filter.due_atRange) {
                const [start, end] = filter.due_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    due_at: {
                    ...where.due_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    due_at: {
                    ...where.due_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.implemented_atRange) {
                const [start, end] = filter.implemented_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    implemented_at: {
                    ...where.implemented_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    implemented_at: {
                    ...where.implemented_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.verified_atRange) {
                const [start, end] = filter.verified_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    verified_at: {
                    ...where.verified_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    verified_at: {
                    ...where.verified_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.action_type) {
                where = {
                    ...where,
                action_type: filter.action_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.capa_actions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'capa_actions',
                        'capa_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.capa_actions.findAll({
            attributes: [ 'id', 'capa_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['capa_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.capa_number,
        }));
    }

    
};

